#include "client_server_interact.h"

#include <engine_engine_number_9/baza_throw.h>
#include "../str_fields.h"

namespace iu9cawebchat {
    std::string when_page_chat(WorkerGuestData& wgd, const json::JSON& config_presentation,
        const een9::ClientRequest& req, const json::JSON& userinfo) {

        std::vector<std::string> path_segs = {""};
        path_segs.reserve(4);
        for (char ch: req.uri_path) {
            if (ch == '/')
                path_segs.emplace_back();
            else
                path_segs.back() += ch;
        }
        // Parameter, passed from server to javascript
        std::string chat_nickname;
        int64_t selected_message_id = -1;
        if (path_segs.size() >= 2) {
            chat_nickname = std::move(path_segs[1]);
        }
        if (!check_nickname(chat_nickname))
            return page_E404(wgd);
        if (path_segs.size() == 2) {
        } else if (path_segs.size() == 4) {
            if (path_segs[2] != "m")
                return page_E404(wgd);
            selected_message_id = std::stoll(path_segs[3]);
            return page_E404(wgd);
        } else
            return page_E404(wgd);

        bool chat_members = (path_segs[0] == "chat-members");


        // todo: do not throw id chat not found, catch exception and return 404
        json::JSON openedchat;
        RowChat_Content chatInfo = lookup_chat_content_by_nickname(*wgd.db, chat_nickname);
        if (get_role_of_user_in_chat(*wgd.db, userinfo["id"].asInteger().get_int(), chatInfo.id) == user_chat_role_deleted) {
            return page_E404(wgd);
        }

        openedchat["name"] = json::JSON(chatInfo.name);
        openedchat["nickname"] = json::JSON(chatInfo.nickname);
        openedchat["id"] = json::JSON(chatInfo.id);
        openedchat["selectedMessageId"] = json::JSON(selected_message_id);  // -1 means that nothing was selected
        json::JSON initial_chatUpdResp = poll_update_chat_ONE_MSG_resp(*wgd.db, chatInfo.id, selected_message_id);
        if (chat_members)
            return http_R200("chat", wgd, {&config_presentation, &userinfo, &openedchat, &initial_chatUpdResp});
        return http_R200("chat", wgd, {&config_presentation, &userinfo, &openedchat, &initial_chatUpdResp});
    }
}
